%VG21 uloha 4 (GPS - zpracovn kodovch meren)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky
%cla;
%clf;

fid = 1;
fid = fopen('vg21_u04.txt','w'); %vytvoreni *.txt souboru pro vystup


tic;%stopky

%gpsconst; %nacten konstant pro vpocty

c = 299792458.0; %rychlost svetla

%zadn -----------------------------------
d1M = 52549; %MJD
t1  = 78840; %cas

d2M = 52549;
t2  = 80040;

d3M = 52549;
t3  = 81240;
%-----------------------------------------

d1 = mjd2civil(d1M); %prevod MJD na normln datum (RRRR MM DD)
d2 = mjd2civil(d2M);
d3 = mjd2civil(d3M);

d1f = fdatum(d1); %prevod datumu z RRRR MM DD na DD MM RR
d2f = fdatum(d2);
d3f = fdatum(d3);


fprintf(fid,'priklad 4.1\n\n');


%--------------------------------------------------------------------------
%  4.1b - urcen polohy stanice 1000
%--------------------------------------------------------------------------



%vyhledn pseudovzlenost
fprintf('\n\nstanice 1000\n');
fprintf('vyhledn pseudovzdlenost (epocha:1');

psd1 = obs_data(d1f,t1,'10002750.02o'); %[PRN , P1 , L1 , P2 , L2]

fprintf(',2');

psd2 = obs_data(d2f,t2,'10002750.02o');

fprintf(',3)\n');

psd3 = obs_data(d3f,t3,'10002750.02o');

psd = [
    psd1
    psd2
    psd3
];

%pocet pseudovzdlenost v jednotlivch epochch
[poc1 pom] = size(psd1);
[poc2 pom] = size(psd2);
[poc3 pom] = size(psd3);

[poc pom] = size(psd);

%vpocet souradnic druzic pro nalezen pseudovzdlenosti
fprintf('vpocet poloh druzic (epocha:1');

druz1 = [];

for i=1:poc1
    
    t = t1 - psd1(i,2) / c; %oprava casu o pseudovzdlenost
    
    druz1(i,:) = druzice_xyz(psd1(i,1),d1f,t,'auto2750.02n'); %[PRN , X , Y , Z , oprava hodin druzice]
end

fprintf(',2');

druz2 = [];

for i=1:poc2
    
    t = t2 - psd2(i,2) / c;
    
    druz2(i,:) = druzice_xyz(psd2(i,1),d2f,t,'auto2750.02n');
end

fprintf(',3)\n');

druz3 = [];

for i=1:poc3
    
    t = t3 - psd3(i,2) / c;
    
    druz3(i,:) = druzice_xyz(psd3(i,1),d3f,t,'auto2750.02n');
end


druz = [
    druz1
    druz2
    druz3
];


fprintf('vyrovnn\n\n\n\n');
XYZ = [0 0 0]; %priblizn poloha urcovanho bodu

A2 = [ %Mat A2 (sloupce 4-6 z Mat A)
    zeros(poc1,1) + 1 , zeros(poc1,1)     , zeros(poc1,1)
    zeros(poc2,1)     , zeros(poc2,1) + 1 , zeros(poc2,1)
    zeros(poc3,1)     , zeros(poc3,1)     , zeros(poc3,1) + 1
];

%----------> FOR START

for i=1:6
    
    %souradnicov rozdly (urcovan bod - druzice)
    Dx = XYZ(1) - druz(:,2);
    Dy = XYZ(2) - druz(:,3);
    Dz = XYZ(3) - druz(:,4);

    %pruvodic (urcovan bod -> druzice)
    ro = ( Dx.^2 + Dy.^2 + Dz.^2 ).^0.5;

    %Mat A
    A1 = [Dx./ro Dy./ro Dz./ro]; %Mat A1 (sloupce 1-3 z Mat A)

    A = [A1 A2];

    %Vec l
    l = ro - psd(:,2) - c .* druz(:,5);

    %vyrovnn
    Q = inv(A' * A);
    dx = -Q * A' * l;
    XYZ = XYZ + dx(1:3)';

end

%----------> FOR END

%stredn chyby

[m,n] = size(A);

v = A * dx + l; %Vec oprav
m0 = ((v' * v) / (m-n))^0.5; %aposteriorn m0
Ql = A * Q * A';
mx = m0 * (diag(Q)).^0.5;  %str.ch.souradnic
ml = m0 * (diag(Ql)).^0.5; %str.ch.meren


%zloha
XYZ_1000 = XYZ;
dx_1000 = dx;
psd_1000 = psd;
druz_1000 = druz;

poc1_1000 = poc1;
poc2_1000 = poc2;
poc3_1000 = poc3;

Dx_1000 = Dx;
Dy_1000 = Dy;
Dz_1000 = Dz;
ro_1000 = ro;



%vpis vsledku

fprintf(fid,'stanice 1000\n');
fprintf(fid,'-----------------------------------------------------\n');
fprintf(fid,' poloha a stredn chyby ve WGS-84\n');
fprintf(fid,'   X = %11.3f m    mx = %.3f m\n',XYZ(1),mx(1));
fprintf(fid,'   Y = %11.3f m    my = %.3f m\n',XYZ(2),mx(2));
fprintf(fid,'   Z = %11.3f m    mz = %.3f m\n\n',XYZ(3),mx(3));

fprintf(fid,' opravy pseudovzdlenost c.dT a jejich stredn chyby\n');
fprintf(fid,'   epocha 1: %7.3f m    m = %.3f m\n',dx(4),mx(4));
fprintf(fid,'   epocha 2: %7.3f m    m = %.3f m\n',dx(5),mx(5));
fprintf(fid,'   epocha 3: %7.3f m    m = %.3f m\n\n',dx(6),mx(6));

fprintf(fid,' celkov aposteriorn m0 = %.3f m\n\n',m0);

fprintf(fid,' pseudovzdlenosti v jednotlivch epochch a jejich stredn chyby (vse v [m])\n');
fprintf(fid,' PRN    pseudovzdlenost    oprava     mi\n');
fprintf(fid,'-------------------------------------------\n');
for i=1:m
    fprintf(fid,'  %2.f      %.3f     %7.3f    %.3f\n',psd(i,1:2),v(i),ml(i));
    
    if((i == poc1) | (i == poc1 + poc2))
        fprintf(fid,'-------------------------------------------\n');
    end
    
end




%--------------------------------------------------------------------------
%  4.1a - urcen polohy stanice 1009
%--------------------------------------------------------------------------



%vyhledn pseudovzlenost
fprintf('stanice 1009\n');
fprintf('vyhledn pseudovzdlenost (epocha:1');

psd1 = obs_data(d1f,t1,'10092750.02o'); %[PRN , P1 , L1 , P2 , L2]

fprintf(',2');

psd2 = obs_data(d2f,t2,'10092750.02o');

fprintf(',3)\n');

psd3 = obs_data(d3f,t3,'10092750.02o');

psd = [
    psd1
    psd2
    psd3
];

%pocet pseudovzdlenost v jednotlivch epochch
[poc1 pom] = size(psd1);
[poc2 pom] = size(psd2);
[poc3 pom] = size(psd3);

[poc pom] = size(psd);

%vpocet souradnic druzic pro nalezen pseudovzdlenosti
fprintf('vpocet poloh druzic (epocha:1');

druz1 = [];

for i=1:poc1
    
    t = t1 - psd1(i,2) / c; %oprava casu o pseudovzdlenost
    
    druz1(i,:) = druzice_xyz(psd1(i,1),d1f,t,'auto2750.02n'); %[PRN , X , Y , Z , oprava hodin druzice]
end

fprintf(',2');

druz2 = [];

for i=1:poc2
    
    t = t2 - psd2(i,2) / c;
    
    druz2(i,:) = druzice_xyz(psd2(i,1),d2f,t,'auto2750.02n');
end

fprintf(',3)\n');

druz3 = [];

for i=1:poc3
    
    t = t3 - psd3(i,2) / c;
    
    druz3(i,:) = druzice_xyz(psd3(i,1),d3f,t,'auto2750.02n');
end


druz = [
    druz1
    druz2
    druz3
];


fprintf('vyrovnn\n\n');
XYZ = [0 0 0]; %priblizn poloha urcovanho bodu

A2 = [ %Mat A2 (sloupce 4-6 z Mat A)
    zeros(poc1,1) + 1 , zeros(poc1,1)     , zeros(poc1,1)
    zeros(poc2,1)     , zeros(poc2,1) + 1 , zeros(poc2,1)
    zeros(poc3,1)     , zeros(poc3,1)     , zeros(poc3,1) + 1
];

%----------> FOR START

for i=1:6
    
    %souradnicov rozdly (urcovan bod - druzice)
    Dx = XYZ(1) - druz(:,2);
    Dy = XYZ(2) - druz(:,3);
    Dz = XYZ(3) - druz(:,4);

    %pruvodic (urcovan bod -> druzice)
    ro = ( Dx.^2 + Dy.^2 + Dz.^2 ).^0.5;

    %Mat A
    A1 = [Dx./ro , Dy./ro , Dz./ro]; %Mat A1 (sloupce 1-3 z Mat A)

    A = [A1 A2];

    %Vec l
    l = ro - psd(:,2) - c .* druz(:,5);

    %vyrovnn
    Q = inv(A' * A);
    dx = -Q * A' * l;
    XYZ = XYZ + dx(1:3)';

end

%----------> FOR END

%stredn chyby

[m,n] = size(A);

v = A * dx + l; %Vec oprav
m0 = ((v' * v) / (m-n))^0.5; %aposteriorn m0
Ql = A * Q * A';
mx = m0 * (diag(Q)).^0.5;  %str.ch.souradnic
ml = m0 * (diag(Ql)).^0.5; %str.ch.meren

%zloha
XYZ_1009 = XYZ;
dx_1009 = dx;
psd_1009 = psd;

druz_1009 = druz;
poc1_1009 = poc1;
poc2_1009 = poc2;
poc3_1009 = poc3;

Dx_1009 = Dx;
Dy_1009 = Dy;
Dz_1009 = Dz;
ro_1009 = ro;

%vpis vsledku

fprintf(fid,'\n\n\nstanice 1009\n');
fprintf(fid,'-----------------------------------------------------\n');
fprintf(fid,' poloha a stredn chyby ve WGS-84\n');
fprintf(fid,'   X = %11.3f m    mx = %.3f m\n',XYZ(1),mx(1));
fprintf(fid,'   Y = %11.3f m    my = %.3f m\n',XYZ(2),mx(2));
fprintf(fid,'   Z = %11.3f m    mz = %.3f m\n\n',XYZ(3),mx(3));

fprintf(fid,' opravy pseudovzdlenost c.dT a jejich stredn chyby\n');
fprintf(fid,'   epocha 1: %7.3f m    m = %.3f m\n',dx(4),mx(4));
fprintf(fid,'   epocha 2: %7.3f m    m = %.3f m\n',dx(5),mx(5));
fprintf(fid,'   epocha 3: %7.3f m    m = %.3f m\n\n',dx(6),mx(6));

fprintf(fid,' celkov aposteriorn m0 = %.3f m\n\n',m0);

fprintf(fid,' pseudovzdlenosti v jednotlivch epochch a jejich stredn chyby (vse v [m])\n');
fprintf(fid,' PRN    pseudovzdlenost    oprava     mi\n');
fprintf(fid,'-------------------------------------------\n');
for i=1:m
    fprintf(fid,'  %2.f      %.3f     %7.3f    %.3f\n',psd(i,1:2),v(i),ml(i));
    
    if((i == poc1) | (i == poc1 + poc2))
        fprintf(fid,'-------------------------------------------\n');
    end
    
end


%--------------------------------------------------------------------------
%  4.2 - urcen polohy stanice 1000 relativne vzhledem k stanici 1009
%--------------------------------------------------------------------------

for j=1:5
%stanice 1000

pomb = [];

for i=1:m
    pom = (XYZ_1000 - druz_1000(i,2:4));
    pomb(i,:) = norm(pom);
end

%                                                                              1    2    3   4   5           6              7    8    9    10
all_1000 = [psd_1000(:,1:2) druz_1000(:,2:5) Dx_1000 Dy_1000 Dz_1000 pomb]; %[PRN , P1 , X , Y , Z , oprava hodin druzice , Dx , Dy , Dz, pruvodic]

uni_1000e1 = sortrows(all_1000(1:poc1_1000,:),1); %serazen jednotlivch epoch podle csel druzic
uni_1000e2 = sortrows(all_1000(poc1_1000+1:poc1_1000+poc2_1000,:),1);
uni_1000e3 = sortrows(all_1000(poc1_1000+poc2_1000+1:end,:),1);

%stanice 1009

all_1009 = [psd_1009(:,1:2) druz_1009(:,2:5) Dx_1009 Dy_1009 Dz_1009 ro_1009];

uni_1009e1 = sortrows(all_1009(1:poc1_1009,:),1);
uni_1009e2 = sortrows(all_1009(poc1_1009+1:poc1_1009+poc2_1009,:),1);
uni_1009e3 = sortrows(all_1009(poc1_1009+poc2_1009+1:end,:),1);

%cern magie
pom1 = uni_1000e1(:,1) - uni_1009e1(:,1);
pom2 = uni_1000e2(:,1) - uni_1009e2(:,1);
pom3 = uni_1000e3(:,1) - uni_1009e3(:,1);

PRN = [pom1 pom2 pom3 uni_1000e1(:,1) uni_1009e1(:,1) uni_1000e2(:,1)  uni_1009e2(:,1) uni_1000e3(:,1)  uni_1009e3(:,1)];

if (sum(sum(PRN(:,1:3))) ~= 0)
    fprintf('   !!! druzice v nekter epose si neodpovdaj, je to treba upravit rucne !!!\n');
    %nechce se mi to programovat...
end





% 1.diference
dif1_psd = [uni_1009e1(:,2) - uni_1000e1(:,2)  , uni_1009e2(:,2)  - uni_1000e2(:,2)  , uni_1009e3(:,2)  - uni_1000e3(:,2)];
dif1_ro = [uni_1009e1(:,10) - uni_1000e1(:,10) , uni_1009e2(:,10) - uni_1000e2(:,10) , uni_1009e3(:,10) - uni_1000e3(:,10)];

% 2.diference
dif2_psd = [dif1_psd(1,1) - dif1_psd(2:end,1) , dif1_psd(1,2) - dif1_psd(2:end,2) , dif1_psd(1,3) - dif1_psd(2:end,3)];
dif2_ro = [dif1_ro(1,1) - dif1_ro(2:end,1) , dif1_ro(1,2) - dif1_ro(2:end,2) , dif1_ro(1,3) - dif1_ro(2:end,3)];





%vyrovnn
A1 = [];

for i=1:poc1-1
    A1(i,:) = ((XYZ_1000 - uni_1000e1(1,3:5)) / uni_1000e1(1,10)) - ((XYZ_1000 - uni_1000e1(i+1,3:5)) / uni_1000e1(i+1,10));
end

A2 = [];

for i=1:poc2-1
    A2(i,:) = ((XYZ_1000 - uni_1000e2(1,3:5)) / uni_1000e2(1,10)) - ((XYZ_1000 - uni_1000e2(i+1,3:5)) / uni_1000e2(i+1,10));
end

A3 = [];

for i=1:poc3-1
    A3(i,:) = ((XYZ_1000 - uni_1000e3(1,3:5)) / uni_1000e3(1,10)) - ((XYZ_1000 - uni_1000e3(i+1,3:5)) / uni_1000e3(i+1,10));
end


A = [
    A1
    A2
    A3
];

l = reshape(dif2_ro - dif2_psd,m-3,1);

Q = inv(A' * A);
dx = Q * A' * l;
XYZ_1000 = XYZ_1000 + dx';

end

%stredn chyby

[m,n] = size(A);

v = A * dx + l;
m0 = ((v' * v)/(m-n))^0.5;
mx = m0 * diag(Q).^0.5;

fprintf(fid,'\n\n\nstanice 1000 urcen relativne vzhledem k stanici 1009\n');
fprintf(fid,'-----------------------------------------------------\n');
%fprintf(fid,' poloha a stredn chyby ve WGS-84\n');
fprintf(fid,'   X = %11.3f m    mx = %.3f m\n',XYZ_1000(1),mx(1));
fprintf(fid,'   Y = %11.3f m    my = %.3f m\n',XYZ_1000(2),mx(2));
fprintf(fid,'   Z = %11.3f m    mz = %.3f m\n\n',XYZ_1000(3),mx(3));

fprintf(fid,' celkov aposteriorn m0 = %.3f m\n\n',m0);





fclose(fid);
fprintf('\n\nCseln vsledky jsou ulozeny v souboru "vg21_u04.txt" v pracovnm adresri\n\n');



fprintf('\ncelkov cas vpoctu %.2f vterin\n',toc);
